<template>
  <div>
    <v-card flat class="pa-10">
      <v-row justify="center">
        <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
          <v-card class="mx-auto">
            <v-toolbar color="grey" dark>
              <v-spacer></v-spacer>
              <v-text-field
                v-model="searchPerfilesUsuario"
                label="Buscar"
                flat
                dark
                solo-inverted
                append-icon="mdi-magnify"
                hide-details
                clear-icon="mdi-close-circle-outline"
              ></v-text-field>
              <v-progress-linear
                :active="isLoadingPerfiles"
                :indeterminate="isLoadingPerfiles"
                absolute
                bottom
                color="primary"
              />
            </v-toolbar>
            <v-list
              height="300"
              max-height="300"
              style="overflow: auto;"
              two-line
              subheader
            >
              <v-subheader style="position : relative;">
                PERFILES ASOCIADOS AL USUARIO
                <v-btn
                  style="top:10px;"
                  color="primary"
                  fab
                  dark
                  small
                  absolute
                  top
                  right
                  @click="getPerfilesUsuario"
                >
                  <v-icon color="white">mdi-sync</v-icon>
                </v-btn>
              </v-subheader>
              <v-list-item-group
                v-model="selectedPerfilesUsuario"
                color="primary"
              >
                <v-list-item
                  :value="item"
                  v-for="(item, indexItem) in searchedPerfilesUsuario"
                  :key="indexItem"
                >
                  <template v-slot:default="{}">
                    <v-list-item-avatar>
                      <v-icon large>mdi-account-group-outline</v-icon>
                    </v-list-item-avatar>
                    <v-list-item-content>
                      <v-list-item-title>
                        <router-link
                          class="text-decoration-underline"
                          :to="toPerfil(item)"
                        >
                          {{ item.descripcion }}
                        </router-link>
                      </v-list-item-title>
                    </v-list-item-content>
                    <v-list-item-action>
                      <v-tooltip bottom>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            class="white--text"
                            color="grey"
                            v-bind="attrs"
                            v-on="on"
                            @click="deletePerfilUsuario(indexItem, item)"
                          >
                            <v-icon>mdi-account-arrow-right-outline</v-icon>
                          </v-btn>
                        </template>
                        <span>Desasociar el perfil</span>
                      </v-tooltip>
                    </v-list-item-action>
                  </template>
                </v-list-item>
              </v-list-item-group>
            </v-list>
          </v-card>
        </v-col>
        <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
          <v-card class="mx-auto">
            <v-toolbar color="grey" dark>
              <v-spacer></v-spacer>
              <v-text-field
                v-model="searchPerfilesDisponibles"
                label="Buscar"
                flat
                dark
                solo-inverted
                append-icon="mdi-magnify"
                hide-details
                clear-icon="mdi-close-circle-outline"
              ></v-text-field>
              <v-progress-linear
                :active="isLoadingDisponibles"
                :indeterminate="isLoadingDisponibles"
                absolute
                bottom
                color="primary"
              />
            </v-toolbar>
            <v-list
              height="300"
              max-height="400"
              style="overflow: auto;"
              two-line
              subheader
            >
              <v-subheader style="position : relative;">
                PERFILES DISPONIBLES
                <v-btn
                  style="top:10px;"
                  color="primary"
                  fab
                  dark
                  small
                  absolute
                  top
                  right
                  @click="getPerfilesDisponibles"
                >
                  <v-icon color="white">mdi-sync</v-icon>
                </v-btn>
              </v-subheader>
              <v-list-item-group
                v-model="selectedPerfilesDisponibles"
                color="primary"
              >
                <v-list-item
                  :value="item"
                  v-for="(item, indexItem) in searchedPerfilesDisponibles"
                  :key="indexItem"
                >
                  <v-list-item-avatar>
                    <v-icon large>mdi-account-group-outline</v-icon>
                  </v-list-item-avatar>
                  <v-list-item-content>
                    <v-list-item-title>
                      <router-link
                        class="text-decoration-underline"
                        :to="toPerfil(item)"
                      >
                        {{ item.descripcion }}
                      </router-link>
                    </v-list-item-title>
                  </v-list-item-content>
                  <v-list-item-action>
                    <v-tooltip bottom>
                      <template v-slot:activator="{ on, attrs }">
                        <v-btn
                          class="white--text"
                          color="grey"
                          v-bind="attrs"
                          v-on="on"
                          @click="postPerfilUsuario(indexItem, item)"
                        >
                          <v-icon>mdi-account-arrow-left-outline</v-icon>
                        </v-btn>
                      </template>
                      <span>Asociar el perfil</span>
                    </v-tooltip>
                  </v-list-item-action>
                </v-list-item>
              </v-list-item-group>
            </v-list>
          </v-card>
        </v-col>
      </v-row>
    </v-card>
  </div>
</template>
<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-Perfiles",
  props: ["usuarioIn"],
  data() {
    return {
      isLoadingPerfiles: false,
      isLoadingDisponibles: false,
      searchPerfilesUsuario: null,
      searchPerfilesDisponibles: null,
      selectedPerfilesUsuario: null,
      selectedPerfilesDisponibles: null,
      perfilesUsuario: [],
      perfilesDisponibles: [],
      usuario: this.usuarioIn,
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    searchedPerfilesUsuario() {
      let tempData = this.perfilesUsuario;
      if (this.searchPerfilesUsuario != "" && this.searchPerfilesUsuario) {
        tempData = tempData.filter((item) => {
          return JSON.stringify(item)
            .toUpperCase()
            .includes(this.searchPerfilesUsuario.toUpperCase());
        });
      }
      if (tempData.length > 0) {
        tempData = tempData.sort((a, b) => {
          let fa = a.descripcion.toLowerCase();
          let fb = b.descripcion.toLowerCase();
          if (fa < fb) {
            return -1;
          }
          if (fa > fb) {
            return 1;
          }
          return 0;
        });
      }
      return tempData;
    },
    searchedPerfilesDisponibles() {
      let tempData = this.perfilesDisponibles;
      if (
        this.searchPerfilesDisponibles != "" &&
        this.searchPerfilesDisponibles
      ) {
        tempData = tempData.filter((item) => {
          return JSON.stringify(item)
            .toUpperCase()
            .includes(this.searchPerfilesDisponibles.toUpperCase());
        });
      }
      if (tempData.length > 0) {
        tempData = tempData.sort((a, b) => {
          let fa = a.descripcion.toLowerCase();
          let fb = b.descripcion.toLowerCase();
          if (fa < fb) {
            return -1;
          }
          if (fa > fb) {
            return 1;
          }
          return 0;
        });
      }
      return tempData;
    },
  },
  methods: {
    toPerfil(perfil) {
      return {
        name: "accesos_perfiles_edicion",
        params: {
          perfil: this.serviceCommons.objectToBase64(perfil),
        },
      };
    },
    deletePerfilUsuario(indexItem, perfil) {
      axios
        .delete(
          "/accesos/sistema/perfiles/v1/" +
            perfil.idPerfil +
            "/usuarios/" +
            this.usuario.numeroEmpleado
        )
        .then((response) => {
          this.perfilesUsuario.splice(indexItem, 1);
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    postPerfilUsuario(indexItem, perfil) {
      axios
        .post(
          "/accesos/sistema/perfiles/v1/" +
            perfil.idPerfil +
            "/usuarios/" +
            this.usuario.numeroEmpleado
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.perfilesUsuario.push(perfil);
            this.perfilesDisponibles.splice(indexItem, 1);
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    getPerfilesUsuario() {
      this.isLoadingPerfiles = true;
      axios(
        "/accesos/sistema/perfiles/v1/usuarios/" + this.usuario.numeroEmpleado
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.perfilesUsuario = data.resultado.perfiles;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.perfilesUsuario = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.isLoadingPerfiles = false;
        });
    },
    getPerfilesDisponibles() {
      this.isLoadingDisponibles = true;
      return axios(
        "/accesos/sistema/perfiles/v1/usuarios/" +
          this.usuario.numeroEmpleado +
          "/disponibles"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            let perfiles = data.resultado.perfiles;
            this.perfilesDisponibles = perfiles;
          }
        })
        .catch((error) => {
          console.log(error);
          this.perfilesDisponibles = [];
        })
        .finally(() => {
          this.isLoadingDisponibles = false;
        });
    },
  },
  created() {
    this.getPerfilesUsuario();
    this.getPerfilesDisponibles();
  },
};
</script>
